'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _request = require('./request');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EventQL = function EventQL(opts) {
  var _this = this;

  (0, _classCallCheck3.default)(this, EventQL);

  this.createTable = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(table, columns) {
      var type = arguments.length <= 2 || arguments[2] === undefined ? 'timeseries' : arguments[2];
      var body;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              body = (0, _assign2.default)({}, {
                database: _this.database,
                table_name: table,
                table_type: type,
                schema: {
                  columns: columns
                }
              });
              _context.next = 4;
              return (0, _request.request)(_this.uri + '/tables/create_table', body, _request.verbs.post, _this.database);

            case 4:
              _context.next = 9;
              break;

            case 6:
              _context.prev = 6;
              _context.t0 = _context['catch'](0);
              throw _context.t0;

            case 9:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this, [[0, 6]]);
    }));

    return function (_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();

  this.insert = function () {
    var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(table, data) {
      var body;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              body = (0, _assign2.default)([], [{
                database: _this.database,
                data: data,
                table: table
              }]);
              _context2.next = 4;
              return (0, _request.request)(_this.uri + '/tables/insert', body, _request.verbs.post);

            case 4:
              _context2.next = 9;
              break;

            case 6:
              _context2.prev = 6;
              _context2.t0 = _context2['catch'](0);
              throw _context2.t0;

            case 9:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this, [[0, 6]]);
    }));

    return function (_x5, _x6) {
      return _ref2.apply(this, arguments);
    };
  }();

  if (!opts.database) {
    throw new Error('Please supply database name as `database`');
  }
  if (!opts.host) {
    throw new Error('Please supply database host as `host`');
  }
  if (!opts.port) {
    throw new Error('Please supply database port as `port`');
  }

  this.database = opts.database;
  this.uri = 'http://' + opts.host + ':' + opts.port + '/api/v1';
};

exports.default = EventQL;