'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.verbs = exports.request = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var log = (0, _debug2.default)('eventql:api');

var verbs = {
  post: 'POST',
  get: 'GET',
  put: 'PUT'
};

var request = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(uri, body) {
    var method = arguments.length <= 2 || arguments[2] === undefined ? 'GET' : arguments[2];
    var database = arguments.length <= 3 || arguments[3] === undefined ? '' : arguments[3];
    var bodyString, headers, req, response, result;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            bodyString = (0, _stringify2.default)(body);


            log('request:', uri, bodyString);

            headers = {
              'Content-Type': 'application/json',
              'Accept': 'application/json',
              'X-EventQL-Namespace': database
            };
            req = (0, _assign2.default)({}, {
              body: bodyString,
              method: method,
              headers: headers
            });
            _context.next = 6;
            return (0, _isomorphicFetch2.default)(uri, req);

          case 6:
            response = _context.sent;

            log('response status:', response.status, response.statusText);

            _context.next = 10;
            return response.text();

          case 10:
            result = _context.sent;

            log('response body', result);

          case 12:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function request(_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

exports.request = request;
exports.verbs = verbs;